minor bug fix
[distro-setup] / check-subvol-stale
index 085025a50d39b7de8f356b2e0a30c1321a1a3d76..07926ef49e3af16535a2d62c915f37cd88552426 100644 (file)
@@ -14,7 +14,7 @@
 # limitations under the License.
 
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
@@ -57,7 +57,7 @@ while true; do
   esac
 done
 
-if [[ ! $@ ]]; then
+if [[ ! $1 ]]; then
   echo "$0: error: expected mountpoint argument"
 fi
 
@@ -82,14 +82,15 @@ for d; do
   vol=${d##*/}
   # second field, non-comment line == $d
   dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab /etc/mtab|head -n1)
+
   d dev=$dev
   subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab /etc/mtab|head -n1)
   d subvol_dir=$subvol_dir
   # note, we need $dev because $d might not be mounted, and we do this loop
   # because the device in fstab for the rootfs can be different.
-  for devx in $(btrfs fi show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
+  for devx in $(btrfs fil show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
     d devx=$devx
-    root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab|head -n1)
+    root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab /etc/fstab|head -n1)
     if [[ $root_dir ]]; then
       d root_dir=$root_dir
       break
@@ -103,17 +104,19 @@ for d; do
   d "svp=$svp # subvolume path"
 
   snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
-  if [[ ! $snaps ]]; then
+  if [[ ! ${snaps[*]} ]]; then
     # no snapshots yet
     echo "$0: warning: no snapshots found at $root_dir/btrbk/$subvol_dir.20*. this is expected for a brand new volume"
     continue
   fi
 
   # get info on last received sub
+  last_received=
   last_received_cgen=0
   for f in ${snaps[@]}; do
     show="$(btrfs sub show $f)"
     if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
+      d found received uuid in $f
       cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
       if [[ $cgen -gt $last_received_cgen ]]; then
         last_received_cgen=$cgen
@@ -121,8 +124,8 @@ for d; do
       fi
     fi
   done
-  d last_received_cgen=$cgen
-  d last_received=$f
+  d last_received_cgen=$last_received_cgen
+  d last_received=$last_received
 
   # Get last_snap by date.
   # when a btrbk bugfix makes it into the distro,
@@ -139,6 +142,7 @@ for d; do
     echo "$0: error: could not find latest snapshot for $svp among ${snaps[*]}" >&2
     exit 1
   fi
+  d last_snap=$last_snap
 
   if [[ ! -e $svp ]]; then
     echo "$0: warning: subvol does not exist: $svp"
@@ -157,7 +161,7 @@ for d; do
     if [[ $svp_cgen -ge $last_received_cgen ]]; then
       stale=false
     else
-      echo "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
+      d "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
       freshest_snap=$last_received
       stale=true
     fi
@@ -170,7 +174,7 @@ for d; do
   stale=true
   # fresh if $svp has $last_snap as a snapshot,
   if btrfs sub show $svp 2>/dev/null | sed '0,/^\s*Snapshot(s):/d;s/^\s*//' | \
-      grep -xF btrbk/$last_snap &>/dev/null; then
+      grep -xF ${last_snap#$root_dir/} ; then
     stale=false
   else # or else $svp is a snapshot of $last_snap. we use a uuid
     # comparison, which if I remember from the docs, is a bit more